(* AUTEURS / AUTHORS :                                     *)
(* Yuxin Deng, Jiatong University, Shanghai                *)
(* Jean-François Monin, Verimag, Université Grenoble Alpes *)
(*                                             2010 - 2019 *)

Require Import finsets.
Require Import notations.

Definition eq_dec_nat : eq_dec ℕ.
Proof.
  intro n; induction n as [| n Hrec]; intro m; destruct m as [ | m].
  - left; trivial.
  - right; discriminate.
  - right; discriminate.
  - destruct (Hrec m) as [ e | ne ].
    + left; case e; reflexivity. 
    + right; intro e; apply ne. injection e. trivial.
Defined.

(* Used in algo_n.v *)
Definition eq_dec_nat2 : eq_dec ℕ² := eq_dec_prod eq_dec_nat eq_dec_nat.

(* Class of nat with decidable equality *)

Instance nat_EqDec : EqDec ℕ.
  constructor. exact eq_dec_nat.
Defined.

(* Class of nat*nat with decidable equality *)

Instance nat2_EqDec : EqDec ℕ² := EDprod nat_EqDec nat_EqDec.
