(* AUTEURS / AUTHORS :                                     *)
(* Yuxin Deng, Jiatong University, Shanghai                *)
(* Jean-François Monin, Verimag, Université Grenoble Alpes *)
(*                                             2010 - 2019 *)


(* ------------------------------------------------------------ *)

Require Import List.
Require Import Nat.
Require Import Arith.
Require Import finsets.
Require Import dec_facts.
Require Import notations.

Definition filter_lt := filter (fun x: ℕ² => let (i,j) := x in ltb i j).

Lemma ltb_lt : forall m n, ltb m n = true -> m < n.
Proof.
  induction m as [| m IHm].
  - destruct n as [| n]. 
    +  discriminate.
    + intros _. apply le_n_S. apply le_0_n.
  - intros n Hn. destruct n as [| n].
    + discriminate Hn. 
    + apply lt_n_S. apply (IHm _ Hn).
Qed.

Lemma filter_lt_list {i j l} : (i,j) ∈ (filter_lt l) -> i < j.
Proof.
  intro i_f. destruct (filter_elim i_f) as [i_l l_ij].
  apply ltb_lt. exact l_ij.
Qed.
