(* AUTEURS / AUTHORS :                                     *)
(* Yuxin Deng, Jiatong University, Shanghai                *)
(* Jean-François Monin, Verimag, Université Grenoble Alpes *)
(*                                             2010 - 2019 *)

Require Import QArith_base.
Require Import finsets.
Require Import notations.

Require Import statement_defs.

Require Import algo_n.


Corollary main_lemma :
  ∀ Prb : ℕ → basic_test → Q, (∀ i t, 0 <= Prb i t) →
  ∀ I0 : set ℕ, I0 ≠ ∅ →
  (∀ i j, (i, j) ∈ I0 × I0 → distinguish Prb i j) →
  ∃ (fI : set ℕ) (ft : test),
    let Pr := Prtest Prb in
    fI ≠ ∅ ∧
    (∀ k, k ∈ fI → 0 < Pr k ft) ∧
    (∀ k, k ∈ I0 \ fI → Pr k ft == 0) ∧
    (∀ i j, i ∈ fI → j ∈ fI → i ≠ j → ¬ Pr i ft == Pr j ft).
Proof.
  intros Prb not_neg_bt  I0 I0_non_empty oracle.
  pose (result := algo_compt_enhanced_test Prb I0 oracle). 
  exists (I'f result). exists (etf result).
  apply correctness.
  - exact not_neg_bt.
  - exact I0_non_empty.
Qed.
