(* AUTEURS / AUTHORS :                                     *)
(* Yuxin Deng, Jiatong University, Shanghai                *)
(* Jean-François Monin, Verimag, Université Grenoble Alpes *)
(*                                             2010 - 2019 *)

Require Import List.
Require Import QArith_base.
Require Import notations.
(* ------------------------------------------------------------------------------ *)

Inductive basic_test : Set :=
  | mk_bt : ℕ -> ℕ -> basic_test.

Definition test : Set := list basic_test.

Section sec_Prb.
  
Variable Prb : ℕ -> basic_test -> Q.

Definition distinguish i j :=
   {t : basic_test | i <> j  ->  ¬ Prb i t == Prb j t}.

Fixpoint Prtest (i : ℕ) (t : test) : Q :=
  match t with
  | nil => 1
  | bt :: t' => Qmult (Prb i bt) (Prtest i t')
  end.

End sec_Prb.

